unit prim;

interface

procedure mst(MainCoord,count: integer); stdcall;


implementation

uses
  classes,
  rwnet_baselist,
  sec;

type
  TLink = record
          node1,node2: smallint;
          dist: single;
          incl: boolean;
        end;

  TLinkList = class(TBaseListSort<TLink>)
  protected
    function  CompareEqual(item1, item2: TLink): boolean; override;
    function  CompareLT(item1, item2: TLink): boolean; override;
    function  CompareGT(item1, item2: TLink): boolean; override;
    procedure SetTrue(index: integer);
  end;

function TLinkList.CompareEqual(item1, item2: TLink): boolean;
begin
  result:= (item1.dist=item2.dist);
end;

function TLinkList.CompareGT(item1, item2: TLink): boolean;
begin
  result:= (item1.dist>item2.dist);
end;

function TLinkList.CompareLT(item1, item2: TLink): boolean;
begin
  result:= (item1.dist<item2.dist);
end;

procedure TLinkList.SetTrue(index: integer);
var
  x: TLink;
begin
  x:= items[index];
  x.incl:= true;
  items[index]:= x;
end;

procedure mst;
var
  v1: TLinkList;
  v1x: TLink;
  x,y: array of double;
  inp: textfile;
  i,j,links: integer;
  onoff: Tbits;
begin
  setlength(x,count);
  setlength(y,count);

  // read x-y values
  assignfile(inp,'~tmp1.txt');
  reset(inp);
  for i:= 0 to count-1 do readln(inp,x[i],y[i]);
  closefile(inp);

  // create distance table
  coordtype:= MainCoord;
  V1:= TLinkList.Create;
  for i:= 0 to count-2 do
  for j:= i+1 to count-1 do
  begin
    v1x.node1:= i;
    v1x.node2:= j;
    v1x.dist:= airdistpos(x[i],x[j],y[i],y[j]);
    v1x.incl:= false;
    v1.Add(v1x);
  end;

  V1.Sort;

  onoff:= Tbits.create;
  onoff.Size:= count;

  v1.SetTrue(0);
  onoff.bits[v1[0].node1]:= true;
  onoff.bits[v1[0].node2]:= true;
  links:= 0;
  while links<count-2 do
  begin
    i:= 1;
    while onoff.bits[v1[i].node1]=onoff.bits[v1[i].node2] do inc(i);
    v1.SetTrue(i);
    onoff.bits[v1[i].node1]:= true;
    onoff.bits[v1[i].node2]:= true;
    inc(links);
  end;
  onoff.Free;

  // output to same file as input
  assignfile(inp,'~tmp1.txt');
  rewrite(inp);
  writeln(inp,'x1 y1 x2 y2');
  for i := 0 to v1.Count-1 do if v1[i].incl then
    writeln(inp,x[v1[i].node1],' ',y[v1[i].node1],' ',x[v1[i].node2],' ',y[v1[i].node2]);
  closefile(inp);

  v1.Free;
  finalize(x);
  finalize(y);
end;

end.
