unit sec;

interface

var
  coordtype: integer;

function AirDistPos(X1,X2,Y1,Y2: double): double;
function AirDist1(X1,X2,Y: double): double;
function AirDist2(Y1,Y2: double): double;
function CoordinateCode(filename: pansichar): smallint; stdcall;


implementation

uses
  sysutils,math;

function CoordinateCode;
var
  mapfile: file of byte;
  coordC: byte;
begin
  // -10: couldn't open file
  // -1: unsupported coordinate system
  // 0-9: Miles, Km etc.
  // 10: LatLong
  // 30-32: Link, Chain, Rod
  try
    filemode:= 0;
    assignfile(mapfile,filename);
    reset(mapfile);
    seek(mapfile,$16D);
    read(mapfile,coordC);
    if coordC=1 then result:= 10 else
    begin
      seek(mapfile,$16F);
      read(mapfile,coordC);
      if coordC in [0..9,30..32] then result:= coordC else result:= -1;
    end;
    closefile(mapfile);
    filemode:= 2;
  except
    on exception do result:= -10;
  end;
end;

function AirDistPos(X1,X2,Y1,Y2: double): double;
begin
  if coordtype=1 then
    result:= 2*6378.13*ArcSIN(sqrt( sqr(SIN((Y2-Y1)/2)) + COS(Y1)*COS(Y2)*sqr(SIN((X2-X1)/2))))
  else if coordtype=2 then
    result:= 2*6378.13*ArcSIN(sqrt( sqr(SIN((Y2-Y1)/2)) + COS(Y1)*COS(Y2)*sqr(SIN((X2-X1)/2))))/1.609
  else
    result:= sqrt(sqr(X1-X2)+sqr(Y1-Y2));
end;

function AirDist1(X1,X2,Y: double): double;
begin
  if coordtype=1 then
    result:= 2*6378.13*ArcSIN(abs(COS(Y)*SIN((X2-X1)/2)))
  else if coordtype=2 then
    result:= 2*6378.13*ArcSIN(abs(COS(Y)*SIN((X2-X1)/2)))/1.609
  else
    result:= abs(X2-X1);
end;

function AirDist2(Y1,Y2: double): double;
begin
  if coordtype=1 then
    result:= 6378.13*abs(Y2-Y1)
  else if coordtype=2 then
    result:= 6378.13*abs(Y2-Y1)/1.609
  else
    result:= abs(Y2-Y1);
end;

end.
